/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_IPADDR
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 1 "bi_ipaddr.m4"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2007, 2008, 2009 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

void
#line 21
bi_ntohl(eval_environ_t env)
#line 21

#line 21 "bi_ipaddr.m4"
{
#line 21
	
#line 21

#line 21

#line 21
long  n;
#line 21
        
#line 21
get_numeric_arg(env, 0, &n);
#line 21
        
#line 21

#line 21
        adjust_stack(env, 1);
#line 21

#line 21
	if (prog_trace_option & BUILTIN_MASK_ipaddr)
#line 21
		prog_trace(env, "ntohl %lu",n);;
#line 21

{
	
#line 23
do {
#line 23
  push(env, (STKVAL) (ntohl((uint32_t) n)));
#line 23
  return;
#line 23
} while (0);
}
}

void
#line 27
bi_htonl(eval_environ_t env)
#line 27

#line 27 "bi_ipaddr.m4"
{
#line 27
	
#line 27

#line 27

#line 27
long  n;
#line 27
        
#line 27
get_numeric_arg(env, 0, &n);
#line 27
        
#line 27

#line 27
        adjust_stack(env, 1);
#line 27

#line 27
	if (prog_trace_option & BUILTIN_MASK_ipaddr)
#line 27
		prog_trace(env, "htonl %lu",n);;
#line 27

{
	
#line 29
do {
#line 29
  push(env, (STKVAL) (htonl((uint32_t) n)));
#line 29
  return;
#line 29
} while (0);
}
}

/* FIXME: The following functions assume binary complement arithmetics.
   This is hardly a limitation, the similar approach works in GNU Radius
   for years. Nevertheless, this assumption should be noted. */

void
#line 37
bi_ntohs(eval_environ_t env)
#line 37

#line 37 "bi_ipaddr.m4"
{
#line 37
	
#line 37

#line 37

#line 37
long  n;
#line 37
        
#line 37
get_numeric_arg(env, 0, &n);
#line 37
        
#line 37

#line 37
        adjust_stack(env, 1);
#line 37

#line 37
	if (prog_trace_option & BUILTIN_MASK_ipaddr)
#line 37
		prog_trace(env, "ntohs %lu",n);;
#line 37

{
	
#line 39
do {
#line 39
  push(env, (STKVAL) ((uint32_t) ntohs(((uint16_t) n) & 0xffff)));
#line 39
  return;
#line 39
} while (0);
}
}

void
#line 43
bi_htons(eval_environ_t env)
#line 43

#line 43 "bi_ipaddr.m4"
{
#line 43
	
#line 43

#line 43

#line 43
long  n;
#line 43
        
#line 43
get_numeric_arg(env, 0, &n);
#line 43
        
#line 43

#line 43
        adjust_stack(env, 1);
#line 43

#line 43
	if (prog_trace_option & BUILTIN_MASK_ipaddr)
#line 43
		prog_trace(env, "htons %lu",n);;
#line 43

{
	
#line 45
do {
#line 45
  push(env, (STKVAL) ((uint32_t) htons(((uint16_t) n) & 0xffff)));
#line 45
  return;
#line 45
} while (0);
}
}

void
#line 49
bi_inet_aton(eval_environ_t env)
#line 49

#line 49 "bi_ipaddr.m4"
{
#line 49
	
#line 49

#line 49

#line 49
char * s;
#line 49
        
#line 49
get_string_arg(env, 0, &s);
#line 49
        
#line 49

#line 49
        adjust_stack(env, 1);
#line 49

#line 49
	if (prog_trace_option & BUILTIN_MASK_ipaddr)
#line 49
		prog_trace(env, "inet_aton %s",s);;
#line 49

{
	struct in_addr addr;

		if (!(inet_aton(s, &addr)))
#line 53
			env_throw_bi(env, mfe_invip, "inet_aton", _("invalid IP address (%s)"),s)
#line 56
;
	
#line 57
do {
#line 57
  push(env, (STKVAL) (ntohl(addr.s_addr)));
#line 57
  return;
#line 57
} while (0);
}
}

void
#line 61
bi_inet_ntoa(eval_environ_t env)
#line 61

#line 61 "bi_ipaddr.m4"
{
#line 61
	
#line 61

#line 61

#line 61
long  ip;
#line 61
        
#line 61
get_numeric_arg(env, 0, &ip);
#line 61
        
#line 61

#line 61
        adjust_stack(env, 1);
#line 61

#line 61
	if (prog_trace_option & BUILTIN_MASK_ipaddr)
#line 61
		prog_trace(env, "inet_ntoa %lu",ip);;
#line 61

{
	struct in_addr addr;

	addr.s_addr = htonl(ip);
	do {pushs(env, inet_ntoa(addr));
#line 66
return;
#line 66
} while (0);
}
}

void
#line 70
bi_len_to_netmask(eval_environ_t env)
#line 70

#line 70 "bi_ipaddr.m4"
{
#line 70
	
#line 70

#line 70

#line 70
long  x;
#line 70
        
#line 70
get_numeric_arg(env, 0, &x);
#line 70
        
#line 70

#line 70
        adjust_stack(env, 1);
#line 70

#line 70
	if (prog_trace_option & BUILTIN_MASK_ipaddr)
#line 70
		prog_trace(env, "len_to_netmask %lu",x);;
#line 70

{
	unsigned long n = (unsigned long) x;
	unsigned long netmask;

		if (!(n <= 32))
#line 75
			env_throw_bi(env, mfe_range, "len_to_netmask", _("invalid netmask: %lu"),n)
;
	n = 32 - n;
	if (n == 32)
		netmask = 0;
	else
		netmask = (0xfffffffful >> n) << n;
	
#line 82
do {
#line 82
  push(env, (STKVAL) (netmask));
#line 82
  return;
#line 82
} while (0);
}
}

void
#line 86
bi_netmask_to_len(eval_environ_t env)
#line 86

#line 86 "bi_ipaddr.m4"
{
#line 86
	
#line 86

#line 86

#line 86
long  x;
#line 86
        
#line 86
get_numeric_arg(env, 0, &x);
#line 86
        
#line 86

#line 86
        adjust_stack(env, 1);
#line 86

#line 86
	if (prog_trace_option & BUILTIN_MASK_ipaddr)
#line 86
		prog_trace(env, "netmask_to_len %lu",x);;
#line 86

{
	unsigned long n = (unsigned long) x;
	unsigned long i;

	for (i = 32; i > 0; i--) {
		if (n & 1)
			break;
		n >>= 1;
	}
	
#line 96
do {
#line 96
  push(env, (STKVAL) (i));
#line 96
  return;
#line 96
} while (0);
}
}


#line 100
void
#line 100
ipaddr_init_builtin()
#line 100
{
#line 100
	#line 21 "bi_ipaddr.m4"
va_builtin_install_ex("ntohl", bi_ntohl, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 27 "bi_ipaddr.m4"
va_builtin_install_ex("htonl", bi_htonl, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 37 "bi_ipaddr.m4"
va_builtin_install_ex("ntohs", bi_ntohs, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 43 "bi_ipaddr.m4"
va_builtin_install_ex("htons", bi_htons, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 49 "bi_ipaddr.m4"
va_builtin_install_ex("inet_aton", bi_inet_aton, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 61 "bi_ipaddr.m4"
va_builtin_install_ex("inet_ntoa", bi_inet_ntoa, 0, dtype_string, 1, 0, 0|0, dtype_number);
#line 70 "bi_ipaddr.m4"
va_builtin_install_ex("len_to_netmask", bi_len_to_netmask, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 86 "bi_ipaddr.m4"
va_builtin_install_ex("netmask_to_len", bi_netmask_to_len, 0, dtype_number, 1, 0, 0|0, dtype_number);

#line 100 "bi_ipaddr.m4"
	
#line 100
}
#line 100



#line 627 "../mfd/snarf.m4"

#line 627

